Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 18517)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 18577)
@@ -635,5 +635,5 @@
     <message>
         <source>Network Adapter</source>
-        <translation type="unfinished">Adaptateur réseau</translation>
+        <translation>Carte réseau</translation>
     </message>
     <message>
@@ -947,10 +947,10 @@
     <message>
         <source>&amp;Network Adapters</source>
-        <translation>&amp;Adaptateur réseau</translation>
+        <translation>&amp;Cartes réseau</translation>
     </message>
     <message>
         <source>Adapter %1</source>
         <comment>network</comment>
-        <translation>Adaptateur %1</translation>
+        <translation>Carte %1</translation>
     </message>
     <message>
@@ -966,9 +966,9 @@
     <message>
         <source>Disconnect the cable from the selected virtual network adapter</source>
-        <translation>Déconnecter le cable de l&apos;adaptateur réseau virtuel</translation>
+        <translation>Déconnecter le cable de la carte réseau virtuel</translation>
     </message>
     <message>
         <source>Connect the cable to the selected virtual network adapter</source>
-        <translation>Connecter le cable de l&apos;adaptateur virtuel réseau sélectionné</translation>
+        <translation>Connecter le cable de la carte virtuel réseau sélectionné</translation>
     </message>
     <message>
@@ -1042,5 +1042,5 @@
         <source>&lt;br&gt;&lt;nobr&gt;&lt;b&gt;Adapter %1 (%2)&lt;/b&gt;: cable %3&lt;/nobr&gt;</source>
         <comment>Network adapters tooltip</comment>
-        <translation>&lt;br&gt;&lt;nobr&gt;&lt;b&gt;Adaptateur %1 (%2)&lt;/b&gt;&amp;nbsp;: cable %3&lt;/nobr&gt;</translation>
+        <translation>&lt;br&gt;&lt;nobr&gt;&lt;b&gt;Carte %1 (%2)&lt;/b&gt;&amp;nbsp;: cable %3&lt;/nobr&gt;</translation>
     </message>
     <message>
@@ -1057,5 +1057,5 @@
         <source>&lt;br&gt;&lt;nobr&gt;&lt;b&gt;All network adapters are disabled&lt;/b&gt;&lt;/nobr&gt;</source>
         <comment>Network adapters tooltip</comment>
-        <translation>&lt;br&gt;&lt;nobr&gt;&lt;b&gt;Tous les adaptateurs réseau sont désactivés&lt;/b&gt;&lt;/nobr&gt;</translation>
+        <translation>&lt;br&gt;&lt;nobr&gt;&lt;b&gt;Tous les cartes réseau sont désactivés&lt;/b&gt;&lt;/nobr&gt;</translation>
     </message>
     <message>
@@ -1717,5 +1717,5 @@
     <message>
         <source>Adapter</source>
-        <translation type="unfinished">Adaptateur</translation>
+        <translation>Carte</translation>
     </message>
     <message>
@@ -2098,5 +2098,5 @@
         <source>Adapter %1</source>
         <comment>details report (network)</comment>
-        <translation>Adaptateur %1</translation>
+        <translation>Carte %1</translation>
     </message>
     <message>
@@ -2695,5 +2695,5 @@
         <source>Adapter %1</source>
         <comment>network</comment>
-        <translation>Adaptateur %1</translation>
+        <translation>Carte %1</translation>
     </message>
     <message>
@@ -3828,5 +3828,5 @@
     <message>
         <source>Failed to remove the host network interface &lt;b&gt;%1&lt;/b&gt;.</source>
-        <translation>Échec de suppression de l&apos;adaptateur réseau &lt;b&gt;%1&lt;/b&gt;.</translation>
+        <translation>Échec de suppression de la carte réseau &lt;b&gt;%1&lt;/b&gt;.</translation>
     </message>
     <message>
@@ -4446,5 +4446,5 @@
     <message>
         <source>&lt;p&gt;Do you want to remove the selected host network interface &lt;nobr&gt;&lt;b&gt;%1&lt;/b&gt;?&lt;/nobr&gt;&lt;/p&gt;&lt;p&gt;&lt;b&gt;Note:&lt;/b&gt; This interface may be in use by one or more network adapters of this or another VM. After it is removed, these adapters will no longer work until you correct their settings by either choosing a different interface name or a different adapter attachment type.&lt;/p&gt;</source>
-        <translation>&lt;p&gt;Désirez-vous éliminer l&apos;interface réseau &lt;nobr&gt;&lt;b&gt;%1&lt;b&gt; sélectionné ?&lt;/nobr&gt;&lt;/p&gt;&lt;p&gt;&lt;b&gt;Note :&lt;/b&gt; cet interface pourait être utilisé par un ou plusieurs adaptateurs réseau de cette ou d&apos;autres machines virtuelles. Si vous éliminez cet interface, les adapteurs virtuels ne fonctionneront plus jusqu&apos;à ce que vous les reconfigurez avec un autre nom d&apos;interface ou un autre type d&apos;accès.&lt;/p&gt;</translation>
+        <translation>&lt;p&gt;Désirez-vous éliminer l&apos;interface réseau &lt;nobr&gt;&lt;b&gt;%1&lt;b&gt; sélectionné ?&lt;/nobr&gt;&lt;/p&gt;&lt;p&gt;&lt;b&gt;Note :&lt;/b&gt; cet interface pourait être utilisé par un ou plusieurs cartes réseau de cette ou d&apos;autres machines virtuelles. Si vous éliminez cet interface, les adapteurs virtuels ne fonctionneront plus jusqu&apos;à ce que vous les reconfigurez avec un autre nom d&apos;interface ou un autre type d&apos;accès.&lt;/p&gt;</translation>
     </message>
     <message>
@@ -5326,5 +5326,5 @@
     <message>
         <source>Network Adapter Statistics</source>
-        <translation>Statistiques adaptateur réseau</translation>
+        <translation>Statistiques carte réseau</translation>
     </message>
     <message>
@@ -5361,5 +5361,5 @@
     <message>
         <source>No Network Adapters</source>
-        <translation>Pas d&apos;adaptateurs réseau</translation>
+        <translation>Pas de cartes réseau</translation>
     </message>
     <message>
@@ -5968,9 +5968,9 @@
     <message>
         <source>When checked, plugs this virtual network adapter into the virtual machine.</source>
-        <translation>Si cette case est cochée, insère l&apos;adaptateur de réseau virtuel dans la machine virtuelle.</translation>
+        <translation>Si cette case est cochée, insère la carte réseau virtuel dans la machine virtuelle.</translation>
     </message>
     <message>
         <source>&amp;Enable Network Adapter</source>
-        <translation>&amp;Activer l&apos;adapteur de Réseau</translation>
+        <translation>&amp;Activer la carte réseau</translation>
     </message>
     <message>
@@ -5988,5 +5988,5 @@
     <message>
         <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
-        <translation>Contrôle la façon dont l&apos;adaptateur virtuel accède au réseau physique de l&apos;ordinateur principal. </translation>
+        <translation>Contrôle la façon dont la carte virtuel accède au réseau physique de l&apos;ordinateur principal. </translation>
     </message>
     <message>
@@ -5996,5 +5996,5 @@
     <message>
         <source>Displays the name of the internal network selected for this adapter.</source>
-        <translation type="obsolete">Affiche le nom du réseau interne affecté à cet adaptateur.</translation>
+        <translation type="obsolete">Affiche le nom du réseau interne affecté à cet carte.</translation>
     </message>
     <message>
@@ -6106,5 +6106,5 @@
     <message>
         <source>Adapter &amp;Type:</source>
-        <translation>&amp;Type d&apos;adaptateur :</translation>
+        <translation>&amp;Type de carte :</translation>
     </message>
     <message>
@@ -6115,5 +6115,5 @@
         <source>Adapter</source>
         <comment>network</comment>
-        <translation type="unfinished">Adaptateur</translation>
+        <translation>Carte</translation>
     </message>
     <message>
@@ -6170,5 +6170,5 @@
     <message>
         <source>no bridged network adapter is selected</source>
-        <translation>aucun adaptateur réseau pour accès par pont n&apos;a été sélectionné</translation>
+        <translation>aucune carte réseau pour accès par pont n&apos;a été sélectionné</translation>
     </message>
     <message>
@@ -6223,9 +6223,9 @@
     <message>
         <source>&amp;Bridged Network Adapter:</source>
-        <translation>Adaptateur réseau pour l&apos;accès par &amp;pont :</translation>
+        <translation>Carte réseau pour l&apos;accès par &amp;pont :</translation>
     </message>
     <message>
         <source>Displays the name of the host network adapter selected for bridged networking.</source>
-        <translation>Affiche le nom de l&apos;adaptateur réseau hôte séléctionné pour l&apos;accès réseau par pont.</translation>
+        <translation>Affiche le nom de la carte réseau hôte séléctionné pour l&apos;accès réseau par pont.</translation>
     </message>
     <message>
@@ -6235,5 +6235,5 @@
     <message>
         <source>Displays the name of the internal network selected for this adapter.</source>
-        <translation>Affiche le nom du réseau interne affecté à cet adaptateur.</translation>
+        <translation>Affiche le nom du réseau interne affecté à cete carte.</translation>
     </message>
     <message>
@@ -6315,5 +6315,5 @@
     <message>
         <source>Displays the MAC address of this adapter. It contains exactly 12 characters chosen from {0-9,A-F}. Note that the second character must be an even digit.</source>
-        <translation>Affiche l&apos;adresse MAC de cet adaptateur. Il comprend exactement 12 caractères choisis entre {0-9,A-F}. Veuillez noter que le second caractère doit être un nombre pair.</translation>
+        <translation>Affiche l&apos;adresse MAC de cette carte. Il comprend exactement 12 caractères choisis entre {0-9,A-F}. Veuillez noter que le second caractère doit être un nombre pair.</translation>
     </message>
     <message>